--
-- Original LUA --
-- MoreBunkersilo Mod by derelky
-- Help to register new fillTypes by Wopster
-- Edits and additions by Michigun Gaming & Outdoors
-- Version 1.0

local modDirectory = g_currentModDirectory

function onLoadMapFinished(mission, node)

    if node ~= 0 then
        local priceStraw = g_fillTypeManager:getFillTypeByName("STRAW").pricePerLiter
        local priceSilage = g_fillTypeManager:getFillTypeByName("SILAGE").pricePerLiter
		
		local cornstalkHudFile = "fillPlanes/hud/hud_fill_cornstalks.png"
        local cornstalkHudFileSmall = "fillPlanes/hud/hud_fill_cornstalks_sml.png"
        local beanstrawHudFile = "fillPlanes/hud/hud_fill_beanstraw.png"
		local beanstrawHudFileSmall = "fillPlanes/hud/hud_fill_beanstraw_sml.png"
				
		local cornstalkHeapDiffuse = Utils.getFilename("fillPlanes/cornstraw2_diffuse.png", modDirectory)
        local cornstalkHeapnormal  = Utils.getFilename("fillPlanes/cornstraw2_normal.png", modDirectory)  
        local cornstalkHeapdistance = Utils.getFilename("fillPlanes/distance/cornstrawdistance_diffuse.png", modDirectory)  
		
        local beanstrawHeapDiffuse  = Utils.getFilename("fillPlanes/beanStraw.png", modDirectory)
        local beanstrawHeapnormal   = Utils.getFilename("fillPlanes/beanStraw_normal.png", modDirectory) 
        local beanstrawHeapdistance = Utils.getFilename("fillPlanes/distance/soybeanStraw_distance.png", modDirectory) 
		
    	--register Fill and Densitymap
		print("Register filltype: corn_stalks and beanstraw")
        local cornstalkFilType = g_fillTypeManager:addFillType("CORN_STALKS", g_i18n:getText("fillType_corn_stalks"), true, priceStraw * 5.2, 0.00045, math.rad(35), cornstalkHudFile, cornstalkHudFileSmall,modDirectory, nil, { 1, 1, 1 }, nil, false)
        local beanstrawFilType = g_fillTypeManager:addFillType("SOYBEANSTRAW", g_i18n:getText("fillType_bean_straw"), true, priceStraw * 5.2, 0.00045, math.rad(35), beanstrawHudFile, beanstrawHudFileSmall, modDirectory, nil, { 1, 1, 1 }, nil, false)
		
		local maizetable = g_fruitTypeManager:getFruitTypeByName("MAIZE")
		local beantable = g_fruitTypeManager:getFruitTypeByName("SOYBEAN")
		local maizedex = maizetable.index
		local beandex = beantable.index

		maizetable.windrowName = 'CORN_STALKS'
		maizetable.hasWindrow = true
		maizetable.windrowLiterPerSqm = 4.37
		beantable.windrowName = 'SOYBEANSTRAW'
		beantable.hasWindrow = true
		beantable.windrowLiterPerSqm = 2.0
		table.insert(g_fruitTypeManager.windrowFillTypes, cornstalkFilType.index, true)
		table.insert(g_fruitTypeManager.windrowFillTypes, beanstrawFilType.index, true)
		
		table.insert(g_fruitTypeManager.fruitTypeIndexToWindrowFillTypeIndex, beandex, beanstrawFilType.index)
		table.insert(g_fruitTypeManager.fruitTypeIndexToWindrowFillTypeIndex, maizedex, cornstalkFilType.index)
		
		table.insert(g_fruitTypeManager.fillTypeIndexToFruitTypeIndex, cornstalkFilType.index, maizedex)
		table.insert(g_fruitTypeManager.fillTypeIndexToFruitTypeIndex, beanstrawFilType.index, beandex)

		local cornstalkHeightmapt = g_densityMapHeightManager:addDensityMapHeightType("CORN_STALKS", math.rad(35), 7, 0.35, 0.1, 0.1, 1.2, false, cornstalkHeapDiffuse, cornstalkHeapnormal, cornstalkHeapdistance, false)
		local beanstrawHeightmapt = g_densityMapHeightManager:addDensityMapHeightType("SOYBEANSTRAW", math.rad(35), 7, 0.35, 0.1, 0.1, 1.2, false, beanstrawHeapDiffuse, beanstrawHeapnormal, beanstrawHeapdistance, false)

		--Load bales -- addBaleType(filename,filltype,isRound,width,height,length,diameter)
		local BeanBaleRFile = Utils.getFilename("bales/roundbales/beanBaleRound.i3d", modDirectory)
		local CornBaleRFile = Utils.getFilename("bales/roundbales/roundbalecorn.i3d", modDirectory)
		local BeanBaleSFile = Utils.getFilename("bales/squarebales/beanBaleSquare.i3d", modDirectory)
		local CornBaleSFile = Utils.getFilename("bales/squarebales/cornstalks.i3d", modDirectory)
		local BeanBaleR = g_baleTypeManager:addBaleType(BeanBaleRFile, "SOYBEANSTRAW", true, 1.12, 0.9, 2.4, 1.3)
		local CornBaleR = g_baleTypeManager:addBaleType(CornBaleRFile, "CORN_STALKS", true, 1.12, 0.9, 2.4, 1.3)
		local BeanBaleS = g_baleTypeManager:addBaleType(BeanBaleSFile, "SOYBEANSTRAW", false, 1.20, 0.9, 2.40, 1.8)
		local CornBaleS = g_baleTypeManager:addBaleType(CornBaleSFile, "CORN_STALKS", false, 1.2, 0.9, 2.4, 1.8)
		
		--load MaterialHolder		
		loadI3DFile(modDirectory .. "fillPlanes/corn_bean_straw.i3d")
		loadI3DFile(modDirectory .. "particleSystems/effect_materialHolder.i3d")	

		--add the new Filltypes to FillCategorys so it can be load in it
		local strawCategory = {"BULK", "WINDROW", "LOADINGVEHICLE","FORAGEWAGON","SILAGETRAILER","FORK","FORAGEHARVESTER","HAYLOFT"}
		for _,k in pairs(strawCategory) do
			g_fillTypeManager:addFillTypeToCategory(cornstalkFilType.index, g_fillTypeManager.nameToCategoryIndex[k])	
			g_fillTypeManager:addFillTypeToCategory(beanstrawFilType.index, g_fillTypeManager.nameToCategoryIndex[k])	
		end
		
		-- refresh FilltypeManager
        g_currentMission.hud.fillLevelsDisplay:refreshFillTypes(g_fillTypeManager)		
		
    end
	
end

function addtoseasonseconomy(mission)
		if g_seasons == nil then
		else
			if g_seasons.economy.data.repricing.fillTypes.CORN_STALKS  == nil then
				g_seasons.economy.data.repricing.fillTypes.CORN_STALKS = {}
				for i,j in pairs(g_seasons.economy.data.repricing.fillTypes.STRAW) do
				g_seasons.economy.data.repricing.fillTypes.CORN_STALKS[i]=j
				end
			end
			if g_seasons.economy.data.repricing.fillTypes.SOYBEANSTRAW  == nil then
				g_seasons.economy.data.repricing.fillTypes.SOYBEANSTRAW = {}
				for i,j in pairs(g_seasons.economy.data.repricing.fillTypes.STRAW) do
				g_seasons.economy.data.repricing.fillTypes.SOYBEANSTRAW[i]=j
				end
			end
		end	
end

function load(id, xmlFile, key,customEnvironment)
	-- Add the new Filltype to the SellingStations
	local hasmaize =false
	local hassoybean =false
	local hascornstalks=false
	local hasbeanstraw =false
	local hasStraw =false
	
	local object=id
		
	
	if object == nil then
	else
		local objClass = object.className
		if objClass == "SellingStation" then
			--print("--1--")
			hasmaize =false
			hassoybean =false
			hascornstalks=false
			hasbeanstraw =false
			hasStraw =false
			for i,filltype in pairs(object.acceptedFillTypes) do
					
				local fillname=g_fillTypeManager.indexToName[i]

				if fillname == "MAIZE" then
					hasmaize=true
								
				end
				if fillname == "SOYBEAN" then
					hassoybean=true
								
				end

				if fillname == "CORN_STALKS" then
					hascornstalks=true
								
				end
				if fillname == "SOYBEANSTRAW" then
					hasbeanstraw=true
								
				end
				if fillname == "STRAW" then
					hasStraw = true
				end
				
			end
				
			if hasStraw and not hascornstalks then
				--add cornstalks to the same SellingStation that accept Straw
				local filltypen = g_fillTypeManager:getFillTypeIndexByName("CORN_STALKS")
				local price = g_fillTypeManager:getFillTypeByName("CORN_STALKS").pricePerLiter
				object:addAcceptedFillType(filltypen,price,true,false)
				object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("CORN_STALKS")]=object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("STRAW")]
				object:initPricingDynamics()
			end
			
			if hasStraw and not hasbeanstraw then
				--add beanstraw to the same SellingStation that accept straw
				local filltypen = g_fillTypeManager:getFillTypeIndexByName("SOYBEANSTRAW")
				local price = g_fillTypeManager:getFillTypeByName("SOYBEANSTRAW").pricePerLiter
				object:addAcceptedFillType(filltypen,price,true,false)
				object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("SOYBEANSTRAW")]=object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("STRAW")]
				object:initPricingDynamics()
			end
		elseif objClass == "AnimalHusbandry" then
			--print("--2--")
			local cornStalk = g_fillTypeManager:getFillTypeIndexByName("CORN_STALKS")
			local beanStraw = g_fillTypeManager:getFillTypeIndexByName("SOYBEANSTRAW")
			table.insert(object.modulesByName.straw.providedFillTypes, cornStalk, true)
			table.insert(object.modulesByName.straw.fillLevels, cornStalk, 0)
			table.insert(object.modulesByName.straw.unloadPlace.fillTypes, cornStalk, true)
			table.insert(object.modulesByName.straw.providedFillTypes, beanStraw, true)
			table.insert(object.modulesByName.straw.fillLevels, beanStraw, 0)
			table.insert(object.modulesByName.straw.unloadPlace.fillTypes, beanStraw, true)
			
			local strawMod = object.modulesByName.straw
			
		elseif objClass == "Vehicle" then
			--print("--3--")
			if object.typeName == "strawBlower" then
				
				local vehSave = object.isVehicleSaved
				
				if object.isVehicleSaved then
					local cornStalk = g_fillTypeManager:getFillTypeIndexByName("CORN_STALKS")
					local beanStraw = g_fillTypeManager:getFillTypeIndexByName("SOYBEANSTRAW")

					for i,k in pairs(object.spec_fillUnit.fillUnits) do
						local suppFill = object.spec_fillUnit.fillUnits[i].supportedFillTypes
						table.insert(suppFill, cornStalk, true)
						table.insert(suppFill, beanStraw, true)
					end
				end
			end
		else
			--print("--4--")
		end
	end
end


-- Hook here
FSBaseMission.loadMapFinished = Utils.prependedFunction(FSBaseMission.loadMapFinished, onLoadMapFinished)
Mission00.loadItemsFinished = Utils.prependedFunction(Mission00.loadItemsFinished, addtoseasonseconomy)
SellingStation.load = Utils.appendedFunction(SellingStation.load, load)
AnimalHusbandry.finalizePlacement = Utils.appendedFunction(AnimalHusbandry.finalizePlacement, load)
--Vehicle.loadFinished = Utils.appendedFunction(Vehicle.loadFinished, load)
